#include <sys/types.h>
#include <sys/stat.h>
#include <sys/ioctl.h>
#include <fcntl.h>
#include <termios.h>
#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define SERIAL_PORT "/dev/ttymxc1"  /* シリアルインターフェースに対応するデバイスファイル */

int main(int argc, char *argv[])
{
	//select使用
	fd_set fds;
	struct timeval tv;

	char buf[256]; /* バッファ */
	char read_buf[2] =
	{ 0 };
	int fd; /* ファイルディスクリプタ */
	struct termios oldtio, newtio; /* シリアル通信設定 */

	char port[256];
	char *get_env = NULL;

	FILE *f;

	if (argc <= 1)
	{
		printf("引数がありません。\n");
		return (-1);
	}

	fd = open(SERIAL_PORT, O_RDWR); /* デバイスをオープンする 　ファイルディスクリプタ*/

	ioctl(fd, TCGETS, &oldtio); /* 現在のシリアルポートの設定を待避させる */
	newtio = oldtio; /* ポートの設定をコピー */
	//hnewtio.c_cflag = ...;             /* ポートの設定をおこなう 詳細はtermios(3)参照 */
	cfsetospeed(&newtio, B9600);  //9600bps
	cfsetspeed(&newtio, B9600);
	newtio.c_lflag &= ~ECHO; //エコー無し
	//追加分
	newtio.c_cflag &= ~PARENB;	//パリティ制御なし
	newtio.c_iflag |= ICRNL;	//キャレッジリターンを改行に変換
	newtio.c_iflag &= ~INPCK;	//パリティチェックなし
	newtio.c_iflag |= IGNCR;	//キャレッジリターンを無視する
	newtio.c_oflag |= OPOST;	//出力有効
	newtio.c_cflag |= CREAD;	//受信可能
	//
	ioctl(fd, TCSETS, &newtio); /* ポートの設定を有効にする */

	memset(buf, 0, 256);

	write(fd, argv[1], strlen(argv[1]));	//起動時の引数を送信
	write(fd, "\n", 1);

	memset(buf, 0, 256);
	//タイムアウト設定

	//タイムアウト時間設定
	tv.tv_sec = 1;
	tv.tv_usec = 0;

	//状態を初期化
	FD_ZERO(&fds);
	//登録
	FD_SET(fd, &fds);
	//監視
	select(fd + 1, &fds, NULL, NULL, &tv);
	if (FD_ISSET(fd, &fds))
	{
		if ((FD_ISSET(fd, &fds)))
		{
			read(fd, buf, 255);	//読込
			printf("%s", buf);
		}
	}
	else
	{
		printf("Timeout Error\n");
		close(fd); /* デバイスのクローズ */
		return (-1);
	}

	//ioctl(fd, TCSETS, &oldtio);       /* ポートの設定を元に戻す */
	close(fd); /* デバイスのクローズ */

	return 0;
}
